'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var SwitcherController = /** @class */ (function (_super) {
    __extends(SwitcherController, _super);
    function SwitcherController() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getProps = function () { return _this.props; };
        _this.state = {
            on: _this.getProps().defaultOn
        };
        // API methods to control Switcher state
        _this.getOn = function () { return _this.state.on; };
        _this.setOn = function (on) {
            _this.setState({ on: on });
        };
        _this.resetOn = function () {
            _this.setState({ on: _this.getProps().defaultOn });
        };
        _this.toggleOn = function () {
            var _a = _this.props, onChange = _a.onChange, name = _a.name;
            _this.setState(function (_a) {
                var on = _a.on;
                return ({ on: !on });
            }, function () {
                return onChange({
                    currentTarget: {
                        name: name,
                        value: _this.state.on
                    }
                });
            });
        };
        return _this;
    }
    SwitcherController.prototype.render = function () {
        var api = {
            getOn: this.getOn,
            setOn: this.setOn,
            resetOn: this.resetOn,
            toggleOn: this.toggleOn
        };
        return this.props.children({ api: api });
    };
    SwitcherController.defaultProps = {
        defaultOn: false
    };
    return SwitcherController;
}(React.Component));

exports.SwitcherController = SwitcherController;
